%
%  numerical integration
%

% example 1 : f(x) = exp(-(x^2))*cos(2*pi*x^2)
%=========================================================================
fun = 'exp(-(x^2))*cos(2*pi*x^2)';

% ends of the interval
a = -2.5; b = 2.5;

% show a plot of the function
figure(1);clf;
ezplot(fun);grid on

% integrate the function between two generic end values
% I=simple(int('exp(-(x^2))*cos(2*pi*x^2)','x','a','b'));
% a numerical value
format long e
vaux_1 = double(simple(int('exp(-(x^2))*cos(2*pi*x^2)','x',a,b)));
% or in this way
% vaux_2 = double(subs(subs(I,'a',a),'b',b));

%gtext(['  int(f(x))_{-5}^{5} (exact) = ' num2str(vaux_1)])

%Np = 30; npg = 3;
fI= gauss_integration(fun,1,npg,Np,a,b);

%gtext(['  int(f(x))_{-5}^{5} (Gauss) npg = ' num2str(npg) ' Np = ' num2str(Np) ' = ' num2str(fI)])

fI_MC= monte_carlo_integration_1D(fun,a,b)

bfh = [bfh;[Np,npg,vaux_1,fI,fI_MC]];