triangle = 0;
npg = 3;
Nx = 20; Ny = 20; 
ax = -2.5; ay = -2.5; bx = 2.5; by=2.5;
fun = 'ff_Ej_4';

psi = (0:Nx)'/Nx; x1 = ax+(bx-ax)*psi; x1 = [x1,0*x1];
eta = (0:Ny)'/Ny; x2 = ay+(by-ay)*eta; x2 = [0*x2,x2];
[xnod,icone] = qq3d(x1,x2);
if triangle , icone = quad2tri(icone); end

if 1
    figure(1);clf;
    pltmsh(xnod,icone);
    axis equal
    hold on
    xlabel('X')
    ylabel('Y')
    title(' Mesh and Gauss point locations - mapping / Ej_4.m ')    
end

[numnp,ndm] = size(xnod);
[numel,nen]  = size(icone);
fI = zeros(numel,1);
if ndm==1
    pgauss1d
    [X2S,S2X,Jaco] = xy2st1d(xnod,icone,psipg);
    [dshapex,N] = shape1d(S2X,psipg,nen);
elseif ndm==2
    pgauss2d  
    for ipg=1:npg
        [X2S,S2X,Jaco] = xy2st(xnod,icone,psipg(ipg),etapg(ipg));
        [dshapex,N] = shape2d(X2S,psipg(ipg),etapg(ipg),nen);
        xsj =  wpg(ipg) .* Jaco;
        % computes the coordinates of each Gauss point
        xpg = zeros(numel,ndm);
        for inod=1:nen
            nodes = icone(:,inod);
            for jdim=1:ndm
                xpg(:,jdim) = xpg(:,jdim) + N(inod).* xnod(nodes,jdim);
            end
        end
        plot(xpg(:,1),xpg(:,2),'r.')
        % evaluate the function at the Gauss point
        eval(['fpg = ' fun '(xpg(:,1),xpg(:,2)).*xsj;'])        
        %fpg = ones(numel,1).*xsj;
        fI = fI + fpg;
    end
elseif ndm==3
    pgauss3d    
    [X2S,S2X,Jaco] = xyz2rst(xnod,icone,psipg,etapg,zetapg);
    [dshapex,N] = shape3d(S2X,psipg,etapg,zetapg,nen);
else
    error(' ndim not allowed ')
end

disp([' Integration of f(x) = ' num2str(sum(fI))])